<template>
  <div class="container">
    <header>
      <h1>{{ barca ? barca.nombre : 'Barca...' }}</h1>
      <div class="buttons">
        <button class="circle" @click="refrescar" :class="{ loading }">
          <LoadingIcono />
        </button>
        <router-link
          tag="button"
          class="primary circle"
          :to="`/barcas/${barcaId}/consensos/crear`"
          v-if="barca && barca.abordada"
        >
          <InIcono />
        </router-link>
      </div>
    </header>
    <nav>
      <div class="links">
        <router-link :to="`/barcas/${barcaId}`">
          En debate
        </router-link>
        <span class="separator">|</span>
        <router-link :to="`/barcas/${barcaId}/archivados`">
          Archivados
        </router-link>
      </div>
    </nav>
    <div v-if="error">
      <template v-if="error === 'forbidden'">
        <h2>No tenés permiso para acceder a esta barca.</h2>
        <p>
          Quizás probá
          <router-link to="/barcas">andando para atrás</router-link>.
        </p>
      </template>
      <h1 v-else>Error: {{ error }}</h1>
    </div>
    <template v-if="consensos.length > 0">
      <template v-for="consenso in consensosNuevos">
        <consenso :consenso="consenso" :barcaId="barcaId" :key="consenso.id" />
        <hr />
      </template>

      <details class="consensos-viejos">
        <summary>Consensos sin actividad por más de un mes</summary>
        <template v-for="consenso in consensosViejos">
          <consenso
            :consenso="consenso"
            :barcaId="barcaId"
            :key="consenso.id"
          />
          <hr />
        </template>
      </details>

      <router-link
        class="red btn-abandonar"
        tag="button"
        :to="`/barcas/${barcaId}/abandonar`"
        v-if="barca && barca.abordada"
      >
        Abandonar barca
      </router-link>
    </template>
    <template v-else-if="!loading">
      <h3>No hay ningun consenso creado.</h3>
    </template>
  </div>
</template>

<script>
import { mapState } from 'vuex'

import CustomButton from '@/components/Button.vue'
import Consenso from '@/components/Consenso.vue'

import InIcono from '@/assets/iconos/in.svg?inline'
import LoadingIcono from '@/assets/iconos/loading.svg?inline'

export default {
  name: 'BarcaView',
  components: {
    CustomButton,
    Consenso,
    InIcono,
    LoadingIcono,
  },
  data() {
    return {
      error: null,
      loading: true,
    }
  },
  computed: {
    barcaId() {
      return parseInt(this.$route.params.id)
    },
    barca() {
      return this.barcas.find(barca => barca.id == this.barcaId)
    },
    ...mapState(['barcas']),
    ...mapState({
      consensos(state) {
        return state.consensos
          .filter(consenso => consenso.barca_id == this.barcaId)
          .sort((a, b) => new Date(b.updated_at) - new Date(a.updated_at))
      },
    }),
    consensosNuevos() {
      return this.consensos.filter(
        consenso =>
          new Date(consenso.updated_at) > Date.now() - 1000 * 60 * 60 * 24 * 30,
      )
    },
    consensosViejos() {
      return this.consensos.filter(
        consenso =>
          new Date(consenso.updated_at) < Date.now() - 1000 * 60 * 60 * 24 * 30,
      )
    },
  },
  methods: {
    refrescar() {
      this.error = null
      this.loading = true
      return Promise.all([
        this.$store.dispatch('conseguirBarca', { barcaId: this.barcaId }),
        this.$store.dispatch('conseguirConsensos', { barcaId: this.barcaId }),
      ])
        .catch(error => (this.error = error))
        .finally(() => (this.loading = false))
    },
  },
  mounted() {
    // fetch data
    this.refrescar()
  },
}
</script>

<style lang="sass" scoped>
header
  display: flex
  align-items: center
  flex-wrap: wrap
  h1
    margin: 0
    font-size: 1em
  .buttons
    display: flex
    justify-content: flex-end
    flex: 1
nav
  display: flex
  flex-wrap: wrap
  align-content: stretch
  align-items: center
  padding: 0.2em 0
  background: var(--background)
  .links
    display: flex
    flex-wrap: wrap
    > a
      color: var(--darkgray)
      text-decoration: none
      &.router-link-exact-active
        color: var(--foreground)
    .separator
      color: var(--accent)
      margin: 0 0.5em

hr
  margin: 0 3em
  color: var(--gray)

.btn-abandonar
  display: block
  margin: 10px auto

.consensos-viejos
  padding: .5em
</style>
